# Filters added to this controller apply to all controllers in the application.
# Likewise, all the methods added will be available for all controllers.

class ApplicationController < ActionController::Base
  # Pick a unique cookie name to distinguish our session data from others'
  session :session_key => '_netadhict_session_id'

  # We want to display graphic overlays, as inline SVG if possible.
  # For inline SVG to work, Firefox requires that the page be marked
  # in the HTTP header as containing "application/xhtml+xml". But
  # IE gags on that. So, we export that content-type only to browsers
  # that explicitly advertise that they support it.
  protected
  def setup_xhtml()
    if (request.env['HTTP_ACCEPT'].match(/application\/xhtml\+xml/))
      headers['Content-Type'] = "application/xhtml+xml; charset=utf-8"
    end
  end

end
