class CreateTraffic < ActiveRecord::Migration
  def self.up
    execute %{CREATE TABLE traffic
              (id                 INT UNSIGNED NOT NULL AUTO_INCREMENT,
               terminal_node_id   INT UNSIGNED NOT NULL,

               ether              INT UNSIGNED NOT NULL DEFAULT 0,
               ether_mpls_uni     INT UNSIGNED NOT NULL DEFAULT 0,
               ether_mpls_multi   INT UNSIGNED NOT NULL DEFAULT 0,
               ether_pppoe_disc   INT UNSIGNED NOT NULL DEFAULT 0,
               ether_pppoe_ss     INT UNSIGNED NOT NULL DEFAULT 0,
               ether_exception_1  INT UNSIGNED NOT NULL DEFAULT 0,
               ether_loop         INT UNSIGNED NOT NULL DEFAULT 0,
               ether_arp          INT UNSIGNED NOT NULL DEFAULT 0,
               ether_rarp         INT UNSIGNED NOT NULL DEFAULT 0,
               ether_ethertalk    INT UNSIGNED NOT NULL DEFAULT 0,
               ether_aarp         INT UNSIGNED NOT NULL DEFAULT 0,
               ether_802_1q       INT UNSIGNED NOT NULL DEFAULT 0,
               ether_ipx          INT UNSIGNED NOT NULL DEFAULT 0,
               ether_novell       INT UNSIGNED NOT NULL DEFAULT 0,
               ether_ipv6         INT UNSIGNED NOT NULL DEFAULT 0,
               ether_ataoe        INT UNSIGNED NOT NULL DEFAULT 0,
               ether_ether_old    INT UNSIGNED NOT NULL DEFAULT 0,

               ether_ipv4                INT UNSIGNED NOT NULL DEFAULT 0,
               ether_ipv4_icmp           INT UNSIGNED NOT NULL DEFAULT 0,
               ether_ipv4_igmp           INT UNSIGNED NOT NULL DEFAULT 0,
               ether_ipv4_eigrp          INT UNSIGNED NOT NULL DEFAULT 0,

               ether_ipv4_udp            INT UNSIGNED NOT NULL DEFAULT 0,
               ether_ipv4_udp_hsrp       INT UNSIGNED NOT NULL DEFAULT 0,
               ether_ipv4_udp_who        INT UNSIGNED NOT NULL DEFAULT 0,
               ether_ipv4_udp_srvloc     INT UNSIGNED NOT NULL DEFAULT 0,
               ether_ipv4_udp_snmp       INT UNSIGNED NOT NULL DEFAULT 0,
               ether_ipv4_udp_rip_v1     INT UNSIGNED NOT NULL DEFAULT 0,
               ether_ipv4_udp_nbns       INT UNSIGNED NOT NULL DEFAULT 0,
               ether_ipv4_udp_nbdgm      INT UNSIGNED NOT NULL DEFAULT 0,
               ether_ipv4_udp_dce_rpc    INT UNSIGNED NOT NULL DEFAULT 0,
               ether_ipv4_udp_ms_sql     INT UNSIGNED NOT NULL DEFAULT 0,
               ether_ipv4_udp_dns        INT UNSIGNED NOT NULL DEFAULT 0,
               ether_ipv4_udp_ntp        INT UNSIGNED NOT NULL DEFAULT 0,
               ether_ipv4_udp_dhcp       INT UNSIGNED NOT NULL DEFAULT 0,
               ether_ipv4_udp_mdns       INT UNSIGNED NOT NULL DEFAULT 0,
               ether_ipv4_udp_rtp        INT UNSIGNED NOT NULL DEFAULT 0,
               ether_ipv4_udp_cups       INT UNSIGNED NOT NULL DEFAULT 0,
               ether_ipv4_udp_xdmcp      INT UNSIGNED NOT NULL DEFAULT 0,
               ether_ipv4_udp_torrent    INT UNSIGNED NOT NULL DEFAULT 0,
               ether_ipv4_udp_ganglia    INT UNSIGNED NOT NULL DEFAULT 0,
               ether_ipv4_udp_ipsec      INT UNSIGNED NOT NULL DEFAULT 0,

               ether_ipv4_tcp              INT UNSIGNED NOT NULL DEFAULT 0,
               ether_ipv4_tcp_http         INT UNSIGNED NOT NULL DEFAULT 0,
               ether_ipv4_tcp_https        INT UNSIGNED NOT NULL DEFAULT 0,
               ether_ipv4_tcp_telnet       INT UNSIGNED NOT NULL DEFAULT 0,
               ether_ipv4_tcp_imap         INT UNSIGNED NOT NULL DEFAULT 0,
               ether_ipv4_tcp_imaps        INT UNSIGNED NOT NULL DEFAULT 0,
               ether_ipv4_tcp_smtp         INT UNSIGNED NOT NULL DEFAULT 0,
               ether_ipv4_tcp_ipp          INT UNSIGNED NOT NULL DEFAULT 0,
               ether_ipv4_tcp_nbss         INT UNSIGNED NOT NULL DEFAULT 0,
               ether_ipv4_tcp_ssh          INT UNSIGNED NOT NULL DEFAULT 0,
               ether_ipv4_tcp_pop          INT UNSIGNED NOT NULL DEFAULT 0,
               ether_ipv4_tcp_pops         INT UNSIGNED NOT NULL DEFAULT 0,
               ether_ipv4_tcp_msnms        INT UNSIGNED NOT NULL DEFAULT 0,
               ether_ipv4_tcp_smb          INT UNSIGNED NOT NULL DEFAULT 0,
               ether_ipv4_tcp_dns          INT UNSIGNED NOT NULL DEFAULT 0,
               ether_ipv4_tcp_ftp          INT UNSIGNED NOT NULL DEFAULT 0,
               ether_ipv4_tcp_rtsp         INT UNSIGNED NOT NULL DEFAULT 0,
               ether_ipv4_tcp_irc          INT UNSIGNED NOT NULL DEFAULT 0,
               ether_ipv4_tcp_mysql        INT UNSIGNED NOT NULL DEFAULT 0,
               ether_ipv4_tcp_nntp         INT UNSIGNED NOT NULL DEFAULT 0,
               ether_ipv4_tcp_dce_rpc      INT UNSIGNED NOT NULL DEFAULT 0,
               ether_ipv4_tcp_xmpp         INT UNSIGNED NOT NULL DEFAULT 0,
               ether_ipv4_tcp_no_payload   INT UNSIGNED NOT NULL DEFAULT 0,
               ether_ipv4_tcp_tcp_sophos   INT UNSIGNED NOT NULL DEFAULT 0,
               ether_ipv4_tcp_ms_streaming INT UNSIGNED NOT NULL DEFAULT 0,
               ether_ipv4_tcp_urd          INT UNSIGNED NOT NULL DEFAULT 0,
               ether_ipv4_tcp_cvs          INT UNSIGNED NOT NULL DEFAULT 0,
               ether_ipv4_tcp_ms_wbt       INT UNSIGNED NOT NULL DEFAULT 0,

               PRIMARY KEY (id),
               UNIQUE KEY (terminal_node_id),
               FOREIGN KEY (terminal_node_id) REFERENCES terminal_nodes(id)
               ON DELETE CASCADE)
              ENGINE=InnoDB}
  end

  def self.down
    execute 'DROP TABLE traffic'
  end
end
