require File.dirname(__FILE__) + '/../test_helper'
require 'trees_controller'

# Re-raise errors caught by the controller.
class TreesController; def rescue_action(e) raise e end; end

class TreesControllerTest < Test::Unit::TestCase
  fixtures :trees

  def setup
    @controller = TreesController.new
    @request    = ActionController::TestRequest.new
    @response   = ActionController::TestResponse.new

    @first_id = trees(:first).id
  end

  def test_index
    get :index
    assert_response :success
    assert_template 'list'
  end

  def test_list
    get :list

    assert_response :success
    assert_template 'list'

    assert_not_nil assigns(:trees)
  end

  def test_show
    get :show, :id => @first_id

    assert_response :success
    assert_template 'show'

    assert_not_nil assigns(:tree)
    assert assigns(:tree).valid?
  end

  def test_new
    get :new

    assert_response :success
    assert_template 'new'

    assert_not_nil assigns(:tree)
  end

  def test_create
    num_trees = Tree.count

    post :create, :tree => {}

    assert_response :redirect
    assert_redirected_to :action => 'list'

    assert_equal num_trees + 1, Tree.count
  end

  def test_edit
    get :edit, :id => @first_id

    assert_response :success
    assert_template 'edit'

    assert_not_nil assigns(:tree)
    assert assigns(:tree).valid?
  end

  def test_update
    post :update, :id => @first_id
    assert_response :redirect
    assert_redirected_to :action => 'show', :id => @first_id
  end

  def test_destroy
    assert_nothing_raised {
      Tree.find(@first_id)
    }

    post :destroy, :id => @first_id
    assert_response :redirect
    assert_redirected_to :action => 'list'

    assert_raise(ActiveRecord::RecordNotFound) {
      Tree.find(@first_id)
    }
  end
end
